Return MACRO arg
	Mov Eax, arg
	Ret
ENDM

HiByte MACRO arg
	Mov Ax, arg
	Shr Ax, 8
ENDM

LoByte MACRO arg
	Mov Ax, arg
	And Ax, 00FFh
ENDM

HiWord MACRO arg
	Mov Eax, arg
	Shr Eax, 16
ENDM

LoWord MACRO arg
	Mov Eax, arg
	And Eax, 0000FFFFH
ENDM

MakeWord MACRO byLow, byHigh
	Push Cx
	Mov Cl, byLow
	Mov Ah, byHigh
	Mov Al, Cl
	Pop Cx
ENDM

MakeLong MACRO wLow, wHigh
	Push Word Ptr wLow
	Mov Ax, wHigh
	Shl Eax, 16
	Pop Ax
ENDM

Color MACRO byRed, byGreen, byBlue
    Xor Eax, Eax
    Mov Ah, byBlue
    Mov Al, byGreen
    Shl Eax,8
    Mov Al, byRed
ENDM

TextAddr MACRO quoted_text:VARARG
    LOCAL ECvname
.Data
    ECvname DB quoted_text,0
.Code
    EXITM <Offset ECvname>
ENDM

;=====================================
; == Programmed by Hctor A. Medina ==
;=====================================
TextAddrW Macro quoted_Unicode_text:VarArg
	Local ECvnameW
	Local cnt,comilla
	Local arg

	strsinpar equ <>
	DWdef  equ <>
	cnt=0
	comilla=0

	DWdef CATSTR <ECvnameW DW  >

	FOR strsinpar,<quoted_Unicode_text>
		ForC arg, <strsinpar>
			IFDIF <arg>,<">
				IF cnt GT 30
					cnt=0 
					.Data
					DWdef
					DWdef TEXTEQU < DW >
					.Code   
			    ENDIF
				cnt=cnt+1
				IF cnt NE 1
					DWdef CATSTR DWdef,<,>
				ENDIF
				IF comilla EQ 1
					DWdef CATSTR DWdef,<">,<arg>,<">
				ELSEIF comilla EQ 0
					DWdef CATSTR DWdef,<strsinpar>
					EXITM
				ENDIF 
			ELSE
				IF comilla EQ 0
					comilla=comilla+1
				ELSE
					comilla=comilla-1
				ENDIF
			ENDIF
		ENDM
	ENDM
	IF cnt NE 0
		DWdef CATSTR DWdef,<,00>
	ELSE
		DWdef CATSTR DWdef,<00>
	ENDIF

.Data
	DWdef
.Code
	ExitM <Offset ECvnameW>
EndM

Text MACRO Name, szstrText:VARARG
	LOCAL ECLabel1
	Jmp ECLabel1
	Name db szstrText,0
ECLabel1:
ENDM

;=====================================
; == Programmed by Hctor A. Medina ==
;=====================================
TextW MACRO Name, quoted_Unicode_text:VARARG
	LOCAL cnt,comilla,arg
	LOCAL ECLabel1

	strsinpar equ <>
	DWdef  equ <>
	cnt=0
	comilla=0

	Jmp ECLabel1
	DWdef TEXTEQU <Name  DW >

	FOR strsinpar,<quoted_Unicode_text>
		FORC arg,<strsinpar>
			IFDIF <arg>,<">
				IF cnt GT 30
					cnt=0 
					DWdef
					DWdef TEXTEQU < DW >
				ENDIF
				cnt=cnt+1
				IF cnt NE 1
					DWdef CATSTR DWdef,<,>
				ENDIF
				IF comilla EQ 1
					DWdef CATSTR DWdef,<">,<arg>,<">
				ELSEIF comilla EQ 0
					DWdef CATSTR DWdef,<strsinpar>
					EXITM
				ENDIF 
			ELSE
				IF comilla EQ 0
					comilla=comilla+1
				ELSE
					comilla=comilla-1
				ENDIF
			ENDIF
		ENDM
	ENDM
	IF cnt NE 0
		DWdef CATSTR DWdef,<,00>
	ELSE
		DWdef CATSTR DWdef,<00>
	ENDIF

	DWdef
ECLabel1:

ENDM

TextStr MACRO quoted_text:VARARG
	ECTextStr Equ <>
	IFDEF APP_UNICODE
		ECTextStr CatStr  <TextAddrW>, <(>, <quoted_text>, <)>
	ELSE
		ECTextStr CatStr  <TextAddr>, <(>, <quoted_text>, <)>
	ENDIF
	ExitM <ECTextStr>
ENDM

TextAddrA MACRO quoted_text:VARARG
	ECTextAddrA Equ <>
	ECTextAddrA CatStr  <TextAddr>, <(>, <quoted_text>, <)>
	ExitM <ECTextAddrA>
ENDM

TextA MACRO quoted_text:VARARG
	ECTextA Equ <>
	ECTextA CatStr  <Text>, <(>, <quoted_text>, <)>
	ExitM <ECTextA>
ENDM

Move MACRO dwValue1, dwValue2
	Push dwValue2
	Pop dwValue1
ENDM

Date MACRO szStrPtr
	Push Esi
	Push Edi
	Invoke GlobalAlloc, GPTR, MAX_PATH
	Mov Esi, Eax
	Invoke GetSystemTime, Esi
	Mov Edi, Esi
	Add Edi, 64
	Invoke GetDateFormat, LOCALE_USER_DEFAULT, LOCALE_NOUSEROVERRIDE, Esi, NULL, Edi, MAX_PATH - 65
	Invoke lstrcpy, szStrPtr, Edi
	Invoke GlobalFree, Esi
	Pop Edi
	Pop Esi
ENDM

Now MACRO szStrPtr
	Push Esi
	Push Edi
	Invoke GlobalAlloc, GPTR, MAX_PATH
	Mov Esi, Eax
	Invoke GetSystemTime, Esi
	Mov Edi, Esi
	Add Edi, 64
	Invoke GetDateFormat, LOCALE_USER_DEFAULT, LOCALE_NOUSEROVERRIDE, Esi, NULL, Edi, MAX_PATH - 65
	Invoke lstrcpy, szStrPtr, Edi
	Invoke lstrcat, szStrPtr, TextAddr(" - ")
	Invoke GetTimeFormat, LOCALE_USER_DEFAULT, LOCALE_NOUSEROVERRIDE, Esi, NULL, Edi, MAX_PATH - 65
	Invoke lstrcat, szStrPtr, Edi
	Invoke GlobalFree, Esi
	Pop Edi
	Pop Esi
ENDM

Time MACRO szStrPtr
	Push Esi
	Push Edi
	Invoke GlobalAlloc, GPTR, MAX_PATH
	Mov Esi, Eax
	Invoke GetSystemTime, Esi
	Mov Edi, Esi
	Add Edi, 64
	Invoke GetTimeFormat, LOCALE_USER_DEFAULT, LOCALE_NOUSEROVERRIDE, Esi, NULL, Edi, MAX_PATH - 65
	Invoke lstrcpy, szStrPtr, Edi
	Invoke GlobalFree, Esi
	Pop Edi
	Pop Esi
ENDM

MultiCat MACRO lpszDesPtr:Req, lpszOrgPtr:VarArg
	Local prm

	FOR prm, <lpszOrgPtr>
		IFNB <prm>
			Invoke lstrcat, lpszDesPtr, prm
		ELSE
			ExitM
		ENDIF
	ENDM
ENDM

Swap MACRO dwValue1, dwValue2
	Push dwValue1
	Push dwValue2
	Pop dwValue1
	Pop dwValue2
ENDM

return  equ <Return>
RETURN  equ <Return>

hibyte  equ <HiByte>
HIBYTE  equ <HiByte>

lobyte  equ <LoByte>
LOBYTE  equ <LoByte>

hiword  equ <HiWord>
HIWORD  equ <HiWord>

loword  equ <LoWord>
LOWORD  equ <LoWord>

makeword    equ <MakeWord>
MAKEWORD    equ <MakeWord>

makelong    equ <MakeLong>
Makelong    equ <MakeLong>
MAKELONG    equ <MakeLong>

color   equ <Color>
COLOR   equ <Color>

move    equ <Move>
MOVE    equ <Move>

multicat	equ <MultiCat>
MULTICAT	equ <MultiCat>

swap    equ <Swap>
SWAP    equ <Swap>


;----------------------------------------------------------------------------------------
ECCall Macro name:Req, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, \
                 p13,p14,p15,p16,p17,p18,p19,p20,p21,p22

      Local prm
      Local spos
      Local slen
      Local prmtype
      Local nametype
      prmstr   equ <>
      paramstr equ <>
      namestr  equ <>
      IF_      equ <>                               ; .IF formado como Sting  => Valor inical NULO
      ENDIF_   equ <>                               ; .EndIF formado como string => Valor inical NULO
     

      ;---Verifica que "name" NO sea cero---
      nametype = OpAttr(name)                       ; Obtiene los atributo del Nombre de la Funcion
         IF (nametype EQ 48) OR (nametype EQ 42) OR (nametype EQ 938) OR (nametype EQ 98); Si es un Reg, Var Local, Var Global
           IF_     CatStr <.IF >,<name>             ; .IF name != 0
           ENDIF_  CatStr <.EndIF>                  ; .EndIf
         ENDIF
      ;-------------------------------------
IF_                                                 ;IF ARTIICIAL: ".IF" o nulo ""
      ;---Scan Inverso de los parametros----
      
 %FOR prm, <p22,p21,p20,p19,p18,p17,p16,p15,p14,p13,\
           p12,p11,p10,p9,p8,p7,p6,p5,p4,p3,p2,p1>
    IFNB <prm>                                      ; Si EXISTE parametro
      spos InStr <prm>, <Addr >                     ; Verifica si en parametro esta el string "Addr"
      %IF spos EQ 1                                 ; El parametro SI tiene "Addr"
         slen SIZESTR <prm>
         prmstr SUBSTR <prm>, 6, slen - 5           ; Len <Addr > = 5
         prmtype = OpAttr(prmstr)                   ; Se obtiene los atributos de la variable que va con "Addr"
         IF (prmtype EQ  42) OR (prmtype EQ 938)    ; Addr Parametro GLOBAL or GLOBAL en MODULO
            paramstr equ <>
            paramstr CatStr <Push Offset >,<prmstr> ; Push Offset Variable Global
            paramstr 

         ELSEIF prmtype EQ  98                      ; Addr Parametro Local
            ;---Truco para preservar Eax---         ; PUSH Addr Variable Local
            Push Eax                                ; PUSH valor Eax
            Lea Eax, prmstr                         ; Addr de la Variable Local
            Xchg Eax, [Esp]                         ; Intercambio de los valores con el Stack
            ;------------------------------
         ELSEIF prmtype EQ  37                      ; label, either local or global
         ELSEIF prmtype EQ  36                      ; immediate operand or constant
         ELSEIF prmtype EQ  48                      ; register
         ELSEIF prmtype EQ  805                     ; local procedure in code
         ELSEIF prmtype EQ  933                     ; external procedure or API call
         ELSE
           ECHO ---------------------------
           ECHO <prmstr> Argumento Invalido
           ECHO ---------------------------
           .ERR
           EXITM 
         ENDIF

      ELSE                                          ; El parametro NO tiene "Addr"

         Push prm                                   ; PUSH PARAMETRO
      ENDIF                                         ; END IF spos EQ 1
    ENDIF                                           ; END IFNB <prm>     
  ENDM
  ;--
                                                    
     Call name                                      ; Call Funcion

ENDIF_                                              ; ENDIF ARTIICIAL: ".EndIF" o nulo ""
  ;--

EndM
;----------------------------------------------------------------------------------------

;-------------------------FORMATO DE ECDeclare---------------------------------------------
;    Zona de .Data
;
;    ECDeclareLib1           DB  "User32.dll",0               ; Library Name 1
;    ECLibHandle1            DD  0                            ; Library Handle 1
;    GetWindowTextAS_        DB  "GetWindowTextA",0           ; API Name
;    GetWindowTextA_         DD  0                            ; DWORD API Address
;    GetClassNameAS_         DB  "GetClassNameA",0            ; API Name
;    GetClassNameA_          DD  0                            ; DWORD API Address
;    .....
;    ECDeclareLib2           DB  "kernel32.dll",0             ; Library Name 2
;    ECLibHandle2            DD  0                            ; Library Handle 2
;    GetWindowsDirectoryAS_  DB  "GetWindowsDirectoryA",0     ; API Name
;    GetWindowsDirectoryA_   DD  0                            ; DWORD API Address
;    GetSystemDirectoryAS_   DB  "GetSystemDirectoryA",0      ; API Name
;    GetSystemDirectoryA_    DD  0                            ; DWORD API Address
;    .....

;    0- Admite repeticion de Nombres de Libreria
;    1- Los Handles se almacenan en las variables: ECLibHandle1, ECLibHandle2, ....
;    2- NO admite repeticion de Nombres de APIs.
;    3- SINTAXIS RECOMENDADA - LIBRARY NAME entre comillas 
;                            - API NAME sin comillas
;       (igualmente todos pueden escribirse con o sin comillas.)
;       Ejemplo de uso:      ECDeclare "User32.dll", GetWindowTextA, GetClassNameA,...
;
;    4- El Nombre de la API es el Declarado con el agregado de un GUION BAJO al final.
;       Ejemplo:               GetWindowTextA_
;                              GetClassNameA_
;    5- SE RECOMIENDA: Colocar ECDeclare en un Modulo con PublicData==TRUE de forma que las
;                      variables DWORD:
;                                a- Con Address de las APIs. 
;                                b- Con Handles de las Librerias Cargadas.
;                      sean accesibles desde cualquier punto del programa. 
;    6- El valor devuelto por ECDeclare en EAX es el handle de la libreria. (EAX <- LibHandle)
;       Puede usar ECUnDeclare para descargar TODAS las librerias Declaradas, o bien usar
;       "FreeLibrary, LibHandle" para descargar una Libreria en particular.               
;******************************************************************************************

ECDeclare Macro LibName:REQ,API:VARARG

         LOCAL LibName, Cnt, Attr, Cpos, SLen

         ECLibName         EQU <>         ; Nombre de la variable con el Nombre de la Libreria
         ECLibHandle       EQU <>         ; Nombre de la variable del Handle de la Libreria
         ECLibLabel        EQU <>         ; Label Declaracion del Nombre de la Libreria-> ECDeclareLib1 DB "User32.dll",0
         ECLibHLabel       EQU <>         ; Label Declaracion del Handle de la Libreria-> ECLibHandle1  DD  0
         
         APIStr            EQU <>         ; Nombre de la API 
         APIStrSc          EQU <>         ; Nombre de la API sin Comillas
         APIName           EQU <>         ; Nombre Interno de la API
         APINameLabel      EQU <>         ; String con el Nombre de la API               -> GetWindowTextAS_  DB  GetWindowTextA,0
         APIDeclareLabel   EQU <>         ; Label donde se declara la variable de la API -> GetWindowTextA_   DD  0    
         StrAux            EQU <>         ; String Auxiliar

         Cnt = 1
:LibNameExist
         ECLibName         EQU <>
         ECLibName         CATSTR <ECDeclareLib>,%Cnt                   ; ECDeclareLib1
         ECLibHandle       EQU <>  
         ECLibHandle       CATSTR <ECLibHandle>,%Cnt                    ; ECLibHandle1
         Attr = OPATTR(ECLibName)
         IF Attr EQ 0                                                   ; NO Existe La Variable
            ECLibLabel     EQU <>
               First SUBSTR <LibName>,1,1                               ; Primer Char del Nombre de la Lib
               IFIDN First, <">                                         ; Si tiene comillas
            ECLibLabel     CATSTR ECLibName,< DB >,<LibName>,<,0>       ; ECDeclareLib1    DB  "User32.dll",0
               ELSE                                                     ; Si NO tiene comillas
            ECLibLabel     CATSTR ECLibName,< DB ">,<LibName>,<",0>     ; ECDeclareLib1    DB  "User32.dll",0
               ENDIF
            ECLibHLabel    EQU <>  
            ECLibHLabel    CATSTR ECLibHandle,< DD  0>                  ; ECLibHandle1     DD  0
            .Data
            ECLibLabel
            ECLibHLabel
            .Code
            Invoke LoadLibrary, ADDR ECLibName
            Mov ECLibHandle, EAX
         ELSE
            Cnt = Cnt + 1
            GOTO LibNameExist
         ENDIF 
;-----------------CARGA DE LAS APIS-------------------------------------------------------

      FOR APIStr, <API>
            APIStrSc          EQU <>  
            APIName           EQU <>  
            APIDeclareLabel   EQU <>
            APINameLabel      EQU <>
            StrAux            EQU <>
                   ;---Verifica si tiene comillas--------
                    Cpos INSTR <APIStr>,<">                            ; Busca Char " en el Nombre de la API
                    IF Cpos NE 0                                       ; Si tiene comillas
                        SLen SIZESTR <APIStr>
                        APIStrSc SUBSTR <APIStr>, 2, SLen - 2          ; Quitas las comillas
                    ELSE
                        APIStrSc CATSTR <APIStr>
                    ENDIF
                   ;-------------------------------------
            StrAux            CATSTR APIStrSc,<S_>                     ; GetWindowTextAS_
            APINameLabel      CATSTR StrAux,<  DB  ">,APIStrSc,<",0>   ; GetWindowTextAS_  DB  GetWindowTextA,0
            APIName           CATSTR APIStrSc,<_>                      ; GetWindowTextA_
            APIDeclareLabel   CATSTR APIName,<  DD  0>                 ; GetWindowTextA_   DD  0
                   
                   ;---Verifica Existencia de la API-----
                    Attr = OPATTR(APIName)
                    IF Attr NE 0 
                     % ECHO  APIName  YA DEFINIDA !!                   ; Da Error si Existe la API
                       .ERR
                       EXITM
                    ENDIF    
                   ;-------------------------------------          
            .Data
            APINameLabel                                               ; GetWindowTextAS_  DB  GetWindowTextA,0
            APIDeclareLabel                                            ; GetWindowTextA_   DD  0
            .Code
            Invoke GetProcAddress, ECLibHandle, ADDR StrAux
            Mov APIName, EAX
       ENDM
       ;--------------Retorno----------------------------
       Mov EAX, ECLibHandle                                            ; EAX <- Handle de la Libreria

EndM

;******************************************************************************************


;-------------------------FORMATO DE ECUnDeclare-------------------------------------------
;  Forma de uso:      ECUnDeclare
;  Operacion:         Descarga TODAS las Librerias Cargadas, buscando los Handles en las
;                     variables: ECLibHandle1, ECLibHandle2, ECLibHandle3,.... y coloca
;                     a cero dichas variables 

ECUnDeclare Macro
         LOCAL Cnt, Attr   

         ECLibHandle       EQU <>         ; Nombre de la variable del Handle de la Libreria

         Cnt = 1                          ; Debe comenzar en 1, para que CATSTR funcione
:LibHandleExist

         ECLibHandle       EQU <>  
         ECLibHandle       CATSTR <ECLibHandle>,%Cnt  
         Attr = OPATTR(ECLibHandle)
         IF Attr NE 0                     ; Existe el Handle
             .Code
             .IF ECLibHandle != 0         ; Si el Handle NO es 0
                 Invoke FreeLibrary, ECLibHandle
                 Mov ECLibHandle, 0       ; Se pone a cero el Handle de la Libreria
             .EndIf
             Cnt = Cnt + 1                ; Loop al proximo Handle
             GOTO LibHandleExist
         ELSE                             ; NO Existe el Handle
             Mov EAX, Cnt                 ; Indica Cuantas Librerias se descargaron
             Dec EAX                      ; Se decrementa porque Cnt comienza en 1
             EXITM
         ENDIF   
EndM

;******************************************************************************************

MLine Macro mlines:VarArg
	      ; Al igual que VB, el separador entre lineas es "::"
	      Local char, spos, slen, sposant, size
          renglon Equ <>
          auxstr Equ <>
          linea Equ <>
 For linea, <mlines>
          sposant = 1
          slen SizeStr <linea>
:NextLinea
      spos InStr sposant, <linea>, <::>
      %IF spos GT 0
;          auxstr TextEqu %spos
;           %Echo auxstr
          auxstr SubStr <linea>, sposant, spos - sposant
              size SizeStr renglon
            IF size NE 0
              renglon CatStr renglon, <,>
            ENDIF
          renglon CatStr renglon, auxstr
          %Echo renglon
          renglon
          renglon Equ <>
          sposant = spos + 2
          GoTo NextLinea
      ELSE
          auxstr SubStr <linea>, sposant, slen - sposant + 1
              size SizeStr renglon
            IF size NE 0
              renglon CatStr renglon, <,>
            ENDIF
          renglon CatStr renglon, auxstr
;          %Echo renglon
      ENDIF

 EndM
               size SizeStr renglon
            IF size NE 0
               %Echo renglon
               renglon
            ENDIF
EndM
;******************************************************************************************


FPInm Macro FPOpcode:Req, IdwValue:Req
         Push DWord Ptr IdwValue
         FPOpcode DWord Ptr [Esp]
         Add Esp, 4
EndM

Add2M Macro dw1:Req, dw2:Req
    Xchg dw2, Eax
    Add Eax, dw3
    Xchg Eax, dw2
;    equivale a
;    Push Eax
;    Mov Eax, dw3
;    Add dw2, Eax
;    Pop Eax
EndM

Add3M Macro dw1:Req, dw2:Req, dw3:Req
    Push dw2
    Xchg [Esp], Eax
    Add Eax, dw3
    Xchg Eax, [Esp]
    Pop dw1
;    equivale a
;    Push Eax
;    Mov Eax, dw2
;    Add Eax, dw3
;    Mov dw1, Eax
;    Pop Eax
EndM
